# sputnik.pm - the Y(aho)o!Sucker project
#
# Version: Prototype 07
#
# Copyright Dirk Diggler & Som One 1996-2002. All rides reserved.
# Coded by Som One and Pierrot Lunaire (French version)
# Redistribution and use, with or without modification,
# is permitted in the sense of GDWYWL
# (GeneralDoWhateverYouWantLicense).
# -z3r0-



###################################
# PACKAGE SUCKER
##########################

package Sucker;

use strict;
use IO::Socket;
use Digest::MD5;


# A class constructor
sub new {
  my $class = shift;
  my $self  = {};
  $self->{config}     = {};
  $self->{cookiez}    = [];
  bless $self, $class;           # but see below
  return $self;
}

# Reads configuration from file
sub load_config {
  my $class = shift;
  my $CONFIG = shift;

  # Let's set the defaults...
  $class->{config} = {
                PORT => "80",
                BOX => "Inbox",
                LEAVE => "1"
                };

  # Now overwrite it by the config file values
  open(CONFILE,"< $CONFIG") or die "Can\'t find the config file\!\n";
  while (<CONFILE>) {
    $| = 1;
    chomp;
    (my $param, my $value) = (split(/\=/))[0,1];
    next unless $param;
    $class->{config}{$param} = $value 
	unless ($param =~ /^\#/ || $param =~ /^\</ || $param =~ /^\ /);
  }
  close(CONFILE);

  ($class->{config}{LOGINHOST} = $class->{config}{HOST}) =~ s/^mail/login/g ;
  ($class->{config}{REPOSIT} = $CONFIG) =~ s/\.conf$/\.repository/g;
  
  $_ = `basename $CONFIG`;
  chomp;
  print "Using ".$_."\n" if $class->{config}{DEBUG};			# DEBUG
}  

# Although called "login", this is the main body of YoSucker
# First I load a home page and get necessary values (challenge, u)
# Then there's a three step login redirect before we actually log in...
sub login {
  my $class = shift;

  # Reads the Yahoo Mail Homepage;
  # Returns challenge and u values in \%valuez
  my $homepage = HomePage->new(\$class->{config}, \$class->{cookiez});
  my $valuez = $homepage->load($class->{config}{HOST}, "\/");

  my $what = "/config\/login?";

  my $username = \$class->{config}{USERNAME};
  my $passwd = \$class->{config}{PASSWD};
  my $box = \$class->{config}{BOX};
  my $reposit = \$class->{config}{REPOSIT};

  my $challenge = $valuez->{"challenge"};
  my $U = $valuez->{"u"};
  my $V = "0";

  my $ctx = Digest::MD5->new;
  $ctx->add($$passwd.$challenge);
  my $hash = $ctx->hexdigest;
  
  print "Login." if $class->{config}{DEBUG};			# DEBUG

  ##
  # STEP 1
  ##

  $what = $what."\.tries=\&\.src=ym\&\.last=\&promo=\&\.intl=us\&\.bypass=".
	  "\&\.partner=\&\.u=".$U."\&\.v=".$V."\&\.challenge=".$challenge.
          "\&\.emailCode=\&hasMsgr=0\&\.chkP=Y\&\.done=\&login=".$$username.
 	  "\&passwd=".$hash."\&\.persistent=\&\.save=1\&\.hash=1\&\.js=1".
	  "\&\.md5=1";

  # Sends login information to login server;
  # Returns first redirect location
  my $page = Page->new(\$class->{config}, \$class->{cookiez});
  my $location = $page->load($class->{config}{LOGINHOST}, $what);


  print "." if $class->{config}{DEBUG};			# DEBUG

  ##
  # STEP 2
  ##

  my $host = (split("\/",$location))[0];
  $location =~ s/$host//g;
  $what = $location;
  chomp($what);
  
  # First login redirect
  # Returns 2nd redirect address
  $location=$page->load($host, $what);

  print "." if $class->{config}{DEBUG};			# DEBUG

  ##
  # STEP 3
  ##

  $host = (split("\/",$location))[0];
  $location =~ s/$host//g;
  $what = $location;
  chomp($what);

  # Second login redirect;
  # Logs in and returns a YY session identifier
  my $thirdpage = ThirdPage->new(\$class->{config}, \$class->{cookiez});
  my $YY = $thirdpage->load($host, $what);

  print "\b\b\b OK.\n" if $class->{config}{DEBUG};			# DEBUG

  ##
  # STEP 4
  ##

  $what = "\/ym\/ShowFolder?rb=".$$box."\&YY=".$YY."\&YN=1";

  print "Reading list of messages..." if $class->{config}{DEBUG};	# DEBUG

  # Loads list of messages (message IDs) from requested BOX
  my $inbox = InboxPage->new(\$class->{config}, \$class->{cookiez});
  my $messgz = $inbox->load($host, $what);

  # Repository basicaly stores a list of already downloaded messages
  # Read repository...

  my %repoz;
  my @new_msgz;
  `touch $$reposit`;
  
  open(FILE, "< $$reposit") or die "No REPOSITORY!!!";
  while (<FILE>) {
	chomp;
	
	# Now,... Yahoo tends to change some parts of message id,
	# for unknown reasons. Therefore I compare just some parts
	# of MesgId that tend to remain the same, though should suffice
	# for message unique identification.
	
	my (@idexp) = (split("_",$_));
	$repoz{$idexp[0].$idexp[5].$idexp[6]} = 1;
  }
  close(FILE);

  print "\n";
  print "Matching repository...\n" if $class->{config}{DEBUG};		# DEBUG

  # Match stored IDs against new downloaded IDs
  foreach my $item (@{$messgz}) {
	my (@idexp) = (split("_",$item));
	unless ($repoz{$idexp[0].$idexp[5].$idexp[6]}) {
		push(@new_msgz, $item);
	}
  }

  if (@new_msgz == 0) {
	print "No new messages.\n\n" if $class->{config}{DEBUG};
  }
  else {
	print "You've got ".@new_msgz." new message(s)!\n" if $class->{config}{DEBUG};
	print "Fetching [" if $class->{config}{DEBUG};

 	open(FILE, ">> $$reposit") or die "No REPOSITORY!!!";

	# Download new messages
  	foreach my $item (@new_msgz) {
   	  $what = "\/ym\/ShowLetter\?box=".$$box."\&MsgId=".$item.
	  	  "\&Search=\&Nhead=f\&YY=".$YY."\&order=down\&sort=date\&pos=0";

	  # Download headers
	  print "." if $class->{config}{DEBUG};
	  my $headz = HeadersPage->new(\$class->{config}, \$class->{cookiez});
	  my $headeritmz = $headz->load($host, $what);
   
	  #   $what = "\/ym\/ShowLetter\?box=Inbox\&MsgId=".$item.
	  #	   "\&toc=1\&Search=\&YY=".$YY."\&order=down\&sort=date\&pos=0";

	  $what = "\/ym\/ShowLetter\/file\.txt\?box=".$$box."\&MsgId=".$item.
		  "\&bodyPart=TEXT\&filename=file\.txt\&download=1\&YY=".$YY.
		  "\&order=down\&sort=date\&pos=0";
	  
	  print "\bo" if $class->{config}{DEBUG};

	  # Parse headers/Download message body
	  my $bodyz = BodyPage->new(\$class->{config}, \$class->{cookiez});
	  $bodyz->load($host, $what, $headeritmz);

	  print "\b#" if $class->{config}{DEBUG};
	  # Save downloaded message ID in the repository
	  print FILE $item."\n";

	}
  
  close(FILE);
  print "] Done.\n\n" if $class->{config}{DEBUG};
  }
}



###################################
# PACKAGE PAGE
##########################

package Page;

sub new {
  my $class = shift;
  my $config = shift;
  my $self  = {};
  $self->{HOST} = $$config->{HOST};
  $self->{PORT} = $$config->{PORT};
  $self->{LOGINHOST} = $$config->{LOGINHOST};
  $self->{USERNAME} = $$config->{USERNAME};
  $self->{PASSWD} = $$config->{PASSWD};
  $self->{OUTFILE} = $$config->{OUTFILE};
  $self->{cookiez} = shift;
  bless $self, $class;
  return $self;
}

# Subroutine CONNECT - used to connect to the server
# Two parameters - host name and port number
# Returns connection handle

sub connect {
  my $class = shift;
  my $host = shift;
  my $port = shift;

  my $handle = IO::Socket::INET->new (Proto       => "tcp",
                                   PeerAddr     => $host,
                                   PeerPort     => $port)
        or die "Can't connect to the server!\n";

  $handle->autoflush(1);
  return $handle;
}

# Function REQUEST sends requst of a specific document to the server
# Has three params - connection handle, what should be fetched 
# and a host name
# Returns ???

sub request {
  my $class = shift;
  my $handle = shift;
  my $what = shift;
  my $host = shift;
  my $cookiez = ${$class->{cookiez}};
  my $line;
  my $cookz_str;

  if (@{$cookiez} > 0) {
	for (my $ii = 0; $ii < @{$cookiez}; $ii++) {
          if ($ii > 0) { $cookz_str = $cookz_str."\; " }
          $cookz_str = $cookz_str.$cookiez->[$ii];
	}
	$line = "GET $what HTTP\/1\.1\nCookie: $cookz_str\nHost: $host\n\n";
  } 
  else {
	$line = "GET $what HTTP\/1\.1\nHost: $host\n\n";
  }

  print $handle $line;
}

# Sub PARSE parses the requst output. Retrieves sent cookies and Location header info.
# One param - connection handle

sub parse {
  my $class = shift;
  my $handle = shift;
  my $cookiez = ${$class->{cookiez}};
  my $line;
  my $location;
  my $count = 0;

  while (defined ($line = <$handle>)) {
          if ( $line =~ /^Set-Cookie: +/) {
                $_ = (split(";",$line))[0];
                s/Set-Cookie: //g;
                $cookiez->[@{$cookiez}] = $_;
		$count++;
		last if $count == 2;
          }
          if ( $line =~ /^Location: +/) {
                $line =~ s/Location: http:\/\///g;
                $location = $line;
          }
  }
  return $location;
}

# LOAD - requests a page and retrieves what we need

sub load {
  my $class = shift;
  my $host = shift;
  my $what = shift;
  my $port = $class->{PORT};

  my $handle = $class->connect($host, $port);
  $class->request($handle, $what, $host);
  my $location = $class->parse($handle);

  return $location;
}



###################################
# PACKAGE HOME PAGE
##########################

package HomePage;
use vars qw(@ISA);
@ISA = "Page";

sub parse {
  my $class = shift;
  my $handle = shift;
  my $cookiez = ${$class->{cookiez}};
  my $line;
  my %valuez;

  while (defined ($line = <$handle>)) {
          if ( $line =~ /name=\"\.challenge\"/) {
		chomp($line);
                $_ = (split("value=\"",$line))[1];
		$_ = (split("\"",$_))[0];
                $valuez{"challenge"} = $_;
		last;
          }
          if ( $line =~ /name=\"\.u\"/) {
		chomp($line);
                $_ = (split("value=\"",$line))[1];
		$_ = (split("\"",$_))[0];
                $valuez{"u"} = $_;
          }
  }
  return \%valuez;
}


###################################
# PACKAGE INBOX PAGE
##########################

package InboxPage;
use vars qw(@ISA);
@ISA = "Page";

sub parse {
  my $class = shift;
  my $handle = shift;
  my $cookiez = ${$class->{cookiez}};
  my $line;
  my @messgz;

  while (defined ($line = <$handle>)) {
          if ( $line =~ /name=\"Mid\"/) {
		chomp($line);
                $_ = (split("value=\"",$line))[1];
		$_ = (split("\"",$_))[0];
                $messgz[@messgz] = $_;
          }
  }
  my @temp = reverse @messgz;		# Put older messages first!!!
  return \@temp;
}


###################################
# PACKAGE THIRD PAGE
##########################

package ThirdPage;
use vars qw(@ISA);
@ISA = "Page";

sub parse {
  my $class = shift;
  my $handle = shift;
  my $cookiez = ${$class->{cookiez}};
  my $line;
  my $yycode;

  while (defined ($line = <$handle>)) {
          if ( $line =~ /^Set-Cookie: +/) {
                $_ = (split(";",$line))[0];
                s/Set-Cookie: //g;
                $cookiez->[@{$cookiez}] = $_;
          }
#         if ( $line =~ /Check Mail/) {
          if ( $line =~ /rb\=Inbox/) {
		chomp($line);
                $_ = (split("YY=",$line))[1];
		$_ = (split("\&",$_))[0];
                $yycode = $_;
		last;
          }
  }
  return $yycode;
}


###################################
# PACKAGE HEADERS PAGE
##########################

package HeadersPage;
use vars qw(@ISA);
@ISA = "Page";

sub parse {
  my $class = shift;
  my $handle = shift;
  my $cookiez = ${$class->{cookiez}};
  my $line;
  my @messgz;
  my $timenow = localtime;
  my @headeritmz;

  $headeritmz[@headeritmz] = "From YoSucker ".$timenow;

  while (defined ($line = <$handle>)) {
        chomp($line);
        if ($line =~ /\:<\/b>/) {
                $line =~ s/<[^>]*>//gs;
                $line =~ s/\&lt\;/</gs;
                $line =~ s/\&gt\;/>/gs;
                $line =~ s/\&#34\;/"/gs;
                $line =~ s/\&nbsp\;\|\&nbsp\;Block Address//gs;
                $line =~ s/\&nbsp\;/ /gs;
		$headeritmz[@headeritmz] = $line;
        }
        undef $line;
  }
  return \@headeritmz;
}

###################################
# PACKAGE BODY PAGE
##########################

package BodyPage;
use vars qw(@ISA);
@ISA = "Page";

# LOAD - requests a page and retrieves what we need

sub load {
  my $class = shift;
  my $host = shift;
  my $what = shift;
  my $headeritmz = shift;
  my $port = $class->{PORT};

  my $handle = $class->connect($host, $port);
  $class->request($handle, $what, $host);
  my $location = $class->parse($handle, $headeritmz);

  return $location;
}

# As Yahoo returns a incomplete Content Type: multipart/... parameter
# I had to come up with this scary looking workaroud
# First three who understand the following code 
# are about to win a "Laden Air"(tm) flight tickets to NY
sub parse {
  my $class = shift;
  my $handle = shift;
  my $headeritmz = shift;
  my $cookiez = ${$class->{cookiez}};
  my $line;
  my @messgz;
  my $outfile = $class->{OUTFILE};
  my $alarm = 0;

  for (my $c = 0; $c < @{$headeritmz}; $c++) {
	if ((($$headeritmz[$c] =~ /^Content\-Type\: multipart/) && 
	   ($$headeritmz[$c] !~ /boundary/i)) && 
           ($$headeritmz[$c+1] !~ /boundary/i)) {
	  
	  $alarm = 1;
        }
  }

  open(FILE, ">> $outfile") or die "Error OUTFILE!!!";

  if ($alarm == 0) {
     my $semaf = 0;

     while (defined ($line = <$handle>)) {
         print FILE $line if $semaf == 1;

	 if ($line eq "\cM\n" ) { 
		# FLUSH Headers
		foreach my $item (@{$headeritmz}) {
		   print FILE $item."\n";
		}
		print FILE "\n";
		$semaf = 1; 
	 }
     }
  }
  else {
     my $semaf = 0;
     $$headeritmz[@{$headeritmz}] = "\n";

     while (defined ($line = <$handle>)) {
        if ($semaf == 1) {
	   if ($alarm == 0) {
		print FILE $line;
	   }
	   else {
		chomp($line);
		$$headeritmz[@{$headeritmz}] = $line;
		if ($line =~ /^--/) {
                	# FLUSH Headers
			$line =~ s/^--//g;
                	foreach my $item (@{$headeritmz}) {
			   $item = $item." boundary=\"".$line."\"" 
				if $item =~ /^Content\-Type\: multipart/;
                   	   print FILE $item."\n";
                	}
			$alarm = 0;
		}
	   }
	}
        if ($line eq "\cM\n" ) {
                $semaf = 1;
        }
     }
  }
  print FILE "\n\n";
  close(FILE);
  return 0;
}


1; # End of it all
